#include "FrustumCullingTraverser.h"

namespace CHCDemo
{

FrustumCullingTraverser::FrustumCullingTraverser(): RenderTraverser() 
{
}


void FrustumCullingTraverser::Render()
{
	while (!mDistanceQueue.empty())
	{
		BvhNode *node = mDistanceQueue.top();
		mDistanceQueue.pop();
	
		// interesting for the visualization, so rest and set
		node->SetVisible(false);
		//mNumTraversedNodes ++;

		//bool intersects;
	
		if (1)//mBvh->InsideViewFrustum(node, intersects))
		{
			// update node's visited flag => needed for rendering
			// so set it also here
			//node->SetLastVisited(mFrameID);
			//node->SetVisible(true);

			TraverseNode(node);
		}
		else
		{
			//mNumFrustumCulledNodes ++;
		}
	}
}

}